/*
 * Copyright 2022 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#include "appnamesort.h"
#include <QLocale>
#include <QCollator>

AppNameSort::AppNameSort(QString appName) : m_appName(appName)
{
}

bool AppNameSort::operator < (const AppNameSort &other) const
{
    QLocale local;
    QString language = local.languageToString(local.language());

    if (QString::compare(language, "Chinese") == 0) {
        local = QLocale(QLocale::Chinese);
    } else {
        local = QLocale(QLocale::English);
    }

    QCollator collator(local);

    if (collator.compare(m_appName, other.getAppName()) < 0) {
        return true;
    } else {
        return false;
    }
}

QString AppNameSort::getAppName() const
{
    return m_appName;
}
