/*
 * Copyright 2022 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef ICONTHEME_H
#define ICONTHEME_H

#include <QObject>

namespace UKUI {

class IconTheme : public QObject
{
    Q_OBJECT
public:
    static IconTheme* getInstance();

    /*!
     * \brief getPathFromName
     * \details get picture file path from icon name
     * \param icon name
     * \return absolute path of picture file
     * \sa KIconTheme
    */
    QString getPathFromName(QString iconName, uint iconSize);

signals:
    //! \brief send while icon theme gsetting changed
    void iconThemeChanged();

private:
    IconTheme();
    void initConnect();
};

} // namespace UKUI

#endif // ICONTHEME_H
