/*
 * Copyright 2022 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef APPMANAGER_H
#define APPMANAGER_H

#include <QObject>
#include "dbusinterfaces/appmanagerinterface.h"
#include <QGSettings>

class AppManager : public QObject
{
    Q_OBJECT
public:
    explicit AppManager(QObject *parent = nullptr);

    Q_INVOKABLE void runApplication(const QString &desktopFile);
    Q_INVOKABLE QList<quint32> runningApplications();
    Q_INVOKABLE void removeApplication(const QString &desktopFile);
    Q_INVOKABLE void runApplicationConfig(const QString &desktopFile, const QStringList &Config);
    Q_INVOKABLE QString AppDesktopFileNameByPid(qlonglong pid);

private:
    AppManagerInterface *m_appManagerInterface;
    QString getUserName();
    QString getPkgNameByDesktop(const QString &desktopFile);
    QString m_userName;
};

#endif // APPMANAGER_H
