/*
 * Copyright 2022 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#include "kylintabletdekstopplugin.h"
#include <QtQml/qqml.h>
#include <QQmlContext>
#include <QDebug>
#include "modelmanager.h"
#include "appmanager.h"
#include "utils/getscreenshot.h"
//#include "KylinItemView/kquickgridview.h"
#include "base/launcheritem.h"
#include "base/categoryitem.h"
#include "core/modelmanager.h"
#include "core/appmanager.h"
#include "core/pluginitem.h"
#include "logger.h"
#include "utils/getscreenshot.h"
#include "utils/desktopbackground.h"
#include "ukui-log4qt.h"
#include "utils/generalsetting.h"
#include "utils/wirelessstatus.h"
#include "utils/wiredlinkstate.h"
#include "utils/accountlogout.h"
#include "utils/blurhelper.h"
#include "utils/gettaskbarvalue.h"
#include "base/trayicon.h"
#include "base/sidebarstate.h"
#include "utils/taskbarmask.h"

void KylinTabletDekstopPlugin::registerTypes(const char *uri)
{
    Q_UNUSED(uri)

#if QT_VERSION <= QT_VERSION_CHECK(5,12,8)
    qmlRegisterType<LauncherItem>("com.kylin.tablet", 1, 0, "LauncherItem");
    qmlRegisterType<CategoryItem>("com.kylin.tablet", 1, 0, "CategoryItem");
    qmlRegisterType<GetScreenShot>("com.kylin.tablet", 1, 0, "ScreenShot");
    qmlRegisterType<DesktopBackground>("com.kylin.tablet", 1, 0, "Background");
//    qmlRegisterType<KQuickGridView>("com.kylin.tablet", 1, 0, "KGridView");
    qmlRegisterType<LauncherItem>("com.kylin.tablet", 1, 0, "LauncherItem");
    qmlRegisterType<CGeneralSetting>("MyGeneralSetting", 1, 0, "CGeneralSetting");
    qmlRegisterType<WirelessStatus>("com.kylin.tablet", 1, 0, "WirelessStatus");
    qmlRegisterType<WiredLinkState>("com.kylin.tablet", 1, 0, "WiredLinkState");
    qmlRegisterType<AccountLogout>("com.kylin.tablet", 1, 0, "AccountLogout");
    qmlRegisterType<BlurHelper>("com.kylin.tablet", 1, 0, "BlurHelper");
    qmlRegisterType<PluginItem>("com.kylin.tablet", 1, 0, "PluginItem");
    qmlRegisterType<TrayIcon>("com.kylin.tablet", 1, 0, "TrayIcon");
    qmlRegisterType<TaskbarMask>("com.kylin.tablet", 1, 0, "TaskbarMask");
#endif
}

void KylinTabletDekstopPlugin::initializeEngine(QQmlEngine *engine, const char *uri)
{
    Q_UNUSED(uri)
    ModelManager *modelManager = new ModelManager(this);
    engine->rootContext()->setContextProperty("modelManager", modelManager);

    AppManager *appMgr = new AppManager(this);
    engine->rootContext()->setContextProperty("appManager", appMgr);
#if 0
    GetTaskbarValue *taskbarValue = new GetTaskbarValue;
    taskbarValue->taskbarModelManager = modelManager;
    engine->rootContext()->setContextProperty("getTaskbarValue", taskbarValue);
#endif

    TrayIcon *trayIcon = new TrayIcon();
    engine->rootContext()->setContextProperty("trayIcon", trayIcon);

    SidebarState *sidebarState = new SidebarState();
    engine->rootContext()->setContextProperty("sidebarState", sidebarState);

}
