/*
 * Copyright 2022 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef ACCOUNTLOGOUT_H
#define ACCOUNTLOGOUT_H

#include <QObject>
#include <QDebug>
#include <QtDBus>
#include<unistd.h>
#include <QtQml>

class AccountLogout : public QObject
{
    Q_OBJECT
#if QT_VERSION >= QT_VERSION_CHECK(5,15,0)
    QML_ELEMENT
#endif

public:
    //暴露给Qml属性的操作
    Q_PROPERTY(QString userName READ getUserName NOTIFY userInfoSignal)
    Q_PROPERTY(QString realName READ getRealName NOTIFY userInfoSignal)

    explicit AccountLogout(QObject *parent = nullptr);

    QString getUserName();

    QString getRealName();

signals:
    void userInfoSignal(QString realName, QString userName);

public slots:
    qlonglong logout();

    void getUserInfo();

private:
    QString myUserName;
    QString myRealName;
};

#endif // ACCOUNTLOGOUT_H
