/*
 * Copyright 2022 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef GETTASKBARVALUE_H
#define GETTASKBARVALUE_H

#include <QObject>
#include <kstartupinfo.h>
#include <QMap>
#include "core/modelmanager.h"
#include "dbusinterfaces/appmanagerinterface.h"
#include "windowmanager/windowmanager.h"

using namespace kdk;

class LauncherItem;
class ModelManagerPrivate;
class ModelManager;

class GetTaskbarValue : public QObject
{
    Q_OBJECT
public:
    explicit GetTaskbarValue(ModelManager *parent = nullptr);
    ~GetTaskbarValue();
    ModelManager* taskbarModelManager;

    void setWindowDesktopFileName(quint32 wid, const QString &fileName);

public slots:
    void setAppClose(WindowId wid);
    void appWindowOpen(WindowId wid);

private:
    QMap<QString, QList<WindowId>> m_isOpenWindows;
    AppManagerInterface *appManagerInterface;
};

#endif // GETTASKBARVALUE_H
