/*
 * Copyright 2022 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef APPWIDGET_H
#define APPWIDGET_H

#include <QWidget>
#include <QObject>
#include "kylin-tablet-desktop-backend.h"

using namespace UKUI;

class AppWidget : public QWidget
{
    Q_OBJECT
public:
    explicit AppWidget(QWidget *parent = nullptr);
    void deleteID(int id);
    ~AppWidget();

    void initUI();

public slots:
    void getSignal();

private:
    kylinTabletDesktopBackend *m_pluginInterface;
    QMap<quint32, BaseItem *> itemInfo;

signals:

};

#endif // APPWIDGET_H
